/****************************************************************/
/*                                                              */
/*   Nome Programma : estrai11.c                                */
/*   Descrizione    : Gestione CGI, solo GET                    */
/*                                                              */
/****************************************************************/


#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define CGI_PATH "cgi-bin/"
#define PACKET_BREAK 5000
#define TEXTPLAIN "text/plain"

/*************** DEFINE gia' presenti in risposta.c *************/
#define METHOD 6
#define VERSION 15
#define RESOURCE 255
#define PROTOCOL 13
#define CODE 4
#define EXPL 40
#define HTTPUDP_STRING "HTTP-UDP/1.0"
#define HTTPTCP_STRING "HTTP-TCP/1.0"


/* Variabili Globali, servono per istanziare i parametri */
char parametro_cgi[10][30];
char *prova_par[10];



/******** PAGINA GESTITA DA GIANLUCA GRANERO *************/
int Cerca_Pagina()
{
  printf(" Sono in Cerca Pagina ");
  return(0);
}



/* Funzione che si occupa della gestione del file nel quale si  */
/* ridirezionato l'output dell'esecuzione del cgi */
char *Gestisci_File(int *lunghezza_body,char *NOME_FILE)
{
 
  int i=0;
  FILE *fp;
  char *body;
  char ch;

  if ((fp=fopen(NOME_FILE,"rb"))==NULL)  /* Apertura del file in lettura */
    {
      perror(NULL); /* stringa d'errore */
      return; //("Errore nel file");
    }
  
  body=(char *)malloc(PACKET_BREAK+1*sizeof(char)); /* Alloco per quanto e' lungo il file */
  
  while (!feof(fp))
     { 
       ch=fgetc(fp);
       body[i]=ch;
       i++;
     }
  
   body[i-1]='\0';
   
   (*lunghezza_body)=i;
   
   fclose(fp);  /* Chiusura del file */
   return(body);
}




/* Funzione che consente di estrarre i parametri ad uno ad uno */
/* dalla lista dei parametri */
int Estrai_Parametri(char *parametri, int *numero, char *parametro_cgi[10])
{
  int che_tipo=0, /* Se 1 linea di comando, se 0 con var. di ambiente */
    v=0,i=0,h=0,count;
  int num_par=1;
  
  while ((parametri[i]!='=')&&(parametri[i]!='+')&&(parametri[i]!='\0'))
    {
      parametro_cgi[num_par][h]=parametri[i];
      i++;
      h++;
    }
  
  
  /* Allora c'e' un unico parametro */
   if (parametri[i]=='\0')
     {
       parametro_cgi[num_par][h]=(char) 0;
       che_tipo=1;
       (*numero)=num_par;
       return(che_tipo);  /* C'e' un unico parametro quindi passaggio su linea di com.*/
     }
   
   
   /* Allora i parametri sono passati su linea di comando */
   if (parametri[i]=='+')
     {
       parametro_cgi[num_par][h]=(char) 0;
       while ((parametri[i]!='\0'))
	 {
	   i++;
	   h=0;
	   num_par++;
	   while ((parametri[i]!='+')&&(parametri[i]!='\0'))
	     {
	       parametro_cgi[num_par][h]=parametri[i];
	       i++;
	      h++;
	     }
	   parametro_cgi[num_par][h]=(char) 0;
	 }
       che_tipo=1;
       num_par++;
       parametro_cgi[num_par]=NULL;
       (*numero)=num_par;
      
     }
   
   
   /* Allora i parametri sono passati per variabili di ambiente */
   if (parametri[i]=='=')
     {
      while ((parametri[i]!='&')&&(parametri[i]!='\0'))
	{
	  parametro_cgi[num_par][h]=parametri[i];
	  i++;
	  h++;
	}
      parametro_cgi[num_par][h]=(char) 0;
      
      while ((parametri[i]!='\0'))
	{
	  i++;
	  h=0;
	  num_par++;
	  while ((parametri[i]!='&')&&(parametri[i]!='\0'))
	    {
	      parametro_cgi[num_par][h]=parametri[i];
	      i++;
	      h++;
	    }
	  parametro_cgi[num_par][h]=(char) 0;
 	  
	}
      che_tipo=0;
      (*numero)=num_par;
      
      return(che_tipo);
     }

   return (che_tipo);
}




/* Funzione che dato l'indirizzo della risorsa effettua il parsing       */
/* verificando se si vuole eseguire un cgi, in caso affermativo si       */
/* estraggono i parametri e si esegue il programma (cgi) redirezinando   */
/* il suo output come input di un file che verra' gestito dalla funzione */
/* Gestione_File */
char *Parser_Address(char *indirizzo,int *nph)
{
  char comando0[255];
  char comando1[255];
  char variabile1[255];
  char variabile2[255];
  
  int count=0,i=0,c=0,h=0,x=0;
  int numero_parametri;
  int che_tipo;
  int lun_body;
  int v;
  int nphono=0;
  char *body;
  char cgi[255];
  char programma[255];
  char parametri[255];
  char *errore;
  
  errore=(char *)calloc(10,sizeof(char));
  
  for(v=0; v<10; v++)
    prova_par[v]=(char *)calloc(30,sizeof(char));
  
  
  (*nph)=0; /* Per default supponiamo che il CGI non e' nph */
  
  //printf(" \n\n\n\n\n");
  
  /** Verifica se si vuole eseguire un Cgi **/
  if (indirizzo[i]=='/')
    {
      cgi[c]=indirizzo[i];
      i++; c++;
      while (indirizzo[i]!='/')
	{
	  //printf(" i=%d\t",i);
	  cgi[c]=indirizzo[i];
	  i++; c++;
	}
      cgi[c]=indirizzo[i];
      c++;
      cgi[c]=(char) 0;
    }
  
  /* Controllo se la risorsa richiesta e' un CGI oppure no */
  if (strcmp(cgi,"/cgi-bin/"))
    {
      Cerca_Pagina();
    }

  else  /* Si vuole eseguire un CGI */
    {
      i++;
      if  (indirizzo[i]=='/')
	{
	  errore="ERRORE";
	  return errore; /* ERRORE di SINTASSI 400:C'e' una / in piu'"); */
	}
      
      /* Si estraggono le prime tre lettere della risorsa per vedere se e' nph */
      for (h=0; h<3; h++)
	{
	  programma[h]=indirizzo[i];
	  i++;
	}
      
      if (!strcmp(programma,"nph")) /* Allora e' un nph */
	{
	  nphono=1;
	  (*nph)=nphono;
	}
      
      
      /*** Cerco il nome del programma da eseguire ***/
      while ((indirizzo[i]!='?')&&(indirizzo[i]!='\0'))
	{
	  programma[h]=indirizzo[i];
	  i++;
	  h++;
	}
      programma[h]=(char) 0;
      
      
      
      /* Allora si vuole eseguire il CGI senza nessun parametro */
      if (indirizzo[i]=='\0')
	{
	  sprintf(comando1,"%s%s > body.txt",CGI_PATH,programma);   /* cgi-bin/calendar");*/
	  system(comando1);
	}


      /*** Se il client vuole eseguire un cgi cerco i parametri  ***/
      if (indirizzo[i]=='?')        /* Allora ci potrebbero essere i parametri */
	{
	  i++;
	  /* Allora errore di sintassi */
	  if (indirizzo[i]=='\0')
	    {
	      errore="ERRORE";
	      return errore; /* ERRORE di SINTASSI 400:Dopo il ? seguono i parametri */
	    }
	  while (indirizzo[i]!='\0')
	    {
	      parametri[x]=indirizzo[i];
	      i++;
	      x++;
	    }
	  parametri[x]=(char) 0;

	  che_tipo=(Estrai_Parametri(parametri,&numero_parametri,prova_par));
	  
	  
	  
	  /* che_tipo=1 allora parametri passati da linea di comando */
	  if (che_tipo)
	    {
	      
	      sprintf(comando1,"%s%s",CGI_PATH,programma);
	      for (count=0; count<numero_parametri; count++)
		{
		  strcat(comando1," ");
		  strcat(comando1,prova_par[count]);
		}
	      strcat(comando1," > body.txt");
	      system(comando1);
	    }
	  
	  else   /* Allora parametri con var. di ambiente */
	    {
	      /* Con putenv si settano le variabili d'ambiente */
	      sprintf(variabile1,"REQUEST_METHOD=GET");
	      putenv(variabile1);
	      sprintf(variabile2,"QUERY_STRING=\"%s\"",parametri);
	      putenv(variabile2);
	      sprintf(comando0,"%s%s > body.txt",CGI_PATH,programma);
	      system(comando0);
            }
	}
      body=Gestisci_File(&lun_body,"body.txt");
    }
  return body;
}




char * Pacchetto_Risposta(char *protocol,char *code,char* expl,char *body)
{
  
  char *date;
  long t;
  char * version=(char *)calloc(PROTOCOL,sizeof(char));
  char *pacchetto_risposta;
  int tot=0;
  
  if (!strcmp(protocol,HTTPUDP_STRING)) strcpy(version,HTTPUDP_STRING);
  else strcpy(version,HTTPTCP_STRING);
  
  time(&t);
  date=(char *)ctime(&t);
  
  
  tot+=(12/*VERSION*/+3/*CODE*/+(strlen(expl)+1)*3/*DOC*/+strlen(date)+1+6/*DATE*/+11/*SERVER*/+30/*LAST MODIFIED*/+16/*CONTENT-TYPE*/+20/*CONTENT-LENGTH*/+2/*riga*/+strlen(body)+1);
  pacchetto_risposta=(char *)calloc(tot+1,sizeof(char));
  
  sprintf(pacchetto_risposta,"%s %s %s\r\nDate: %sServer: GFG/1.0\r\nLast-modified: %sContent-length: %d\r\n%s",version,code,expl,date,date,strlen(body)-23,body);
  pacchetto_risposta[tot+1]='\0';

  return pacchetto_risposta;
  
}






char* analizza_richiesta(char *in)
{
  /*SOLO GET  */
  char *out;
  int nph;
  
  char method[METHOD],version[VERSION],resource[RESOURCE];
  int ok=1,tcp,rispondi_udp,esiste_pagina;

  char protocol[PROTOCOL],code[CODE],expl[EXPL],*body;
  
  sscanf(in,"%s %s %s",method,resource,version);
  
  
  body=Parser_Address(resource,&nph);
  
  //printf(" BODY = %s",body);
  //printf(" NPH : %d\n",nph);
  
  /* Se nph=1 allora si e' richiesta l'esecuzione di un nph     */
  /* pertanto in body ho direttamente tutto il pacchetto di risposta */
  if (nph) return body;
  
  /* Altrimenti se tipo_cgi=1 il CGI e' un ph per cui in body e' presente */
  /* il content-type, la riga vuota e l'output del CGI  */
  if (body=="ERRORE")
    {
      strcpy(code,"400");
      strcpy(expl,"Errore nella richiesta");
      body=(char *)calloc(200,sizeof(char));
      sprintf(body,"Content-type: %s\r\n\r\nERRORE di sintassi nella richiesta",TEXTPLAIN);
      
    }
  else
    {
      strcpy(code,"200");
      strcpy(expl,"Segue risorsa");
    }
  
  
  tcp=!strcmp(HTTPTCP_STRING,version);
  
  if (tcp) strcpy(protocol,HTTPTCP_STRING);
  else  strcpy(protocol,HTTPUDP_STRING);
  
  out=Pacchetto_Risposta(protocol,code,expl,body);

  return out;
}




/* MAIN */
int main(int argc,char** argv)
{
  char *body;
  char *p,
    
  /********* POSSIBILI RICHIESTE DEL CLIENT ************/
    
  /***** PARAMETRI SU LINEA DI COMANDO ******/
    //*data="GET /cgi-bin/cgirigacomando?2+1999  HTTP-UDP/1.0";
    //*data="GET /cgi-bin/cgirigacomando?1 HTTP-UDP/1.0";
    //*data="GET /cgi-bin/cgirigacomando HTTP-UDP/1.0";
    
  /***** PARAMETRI PER VARIABILI D'AMBIENTE ******/
    //*data="GET /cgi-bin/cgivariabile?pippo=5&pluto=parola HTTP-UDP/1.0";
    //*data="GET /cgi-bin/cgivariabile?width=5&link=parola HTTP-UDP/1.0";

  /***** POSSIBILI nph *****/
    *data="GET /cgi-bin/nph-cgi?width=5&link=parola HTTP-UDP/1.0";
    //*data="GET /cgi-bin/nph-cgi?pippo+pluto HTTP-UDP/1.0";
    //*data="GET /cgi-bin/nph-cgi?1 HTTP-UDP/1.0";

  /********* POSSIBILI ERRORI DI SINTASSI DEL CLIENT ************/
    // *data="GET /cgi-bin/cgirigacomando? HTTP-UDP/1.0";
    // *data="GET /cgi-bin//cgirigacomando?1+1999 HTTP-UDP/1.0";

  body=analizza_richiesta(data);
  printf(" PACCHETTO DI RISPOSTA :\n\n%s\n\n",body);
  
  return(0);
}    /* END MAIN */
  



//INDIRIZZO granero@usa.net





